// $ANTLR 2.7.1: "java.tree.g" -> "GeneratedJavaTreeParser.java"$

package com.puppycrawl.tools.checkstyle;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


/**
 * Java 1.2 AST Recognizer Grammar
 *
 * Based heavily on the Grammer example that comes with ANTLR. See
 * http://www.antlr.org.
 *
 */
public class GeneratedJavaTreeParser extends antlr.TreeParser
       implements GeneratedJavaTreeParserTokenTypes
 {
public GeneratedJavaTreeParser() {
	tokenNames = _tokenNames;
}

	public final void compilationUnit(AST _t) throws RecognitionException {
		
		MyCommonAST compilationUnit_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PACKAGE_DEF:
			{
				packageDefinition(_t);
				_t = _retTree;
				break;
			}
			case 3:
			case CLASS_DEF:
			case INTERFACE_DEF:
			case IMPORT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			_loop4:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==IMPORT)) {
					importDefinition(_t);
					_t = _retTree;
				}
				else {
					break _loop4;
				}
				
			} while (true);
			}
			{
			_loop6:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==CLASS_DEF||_t.getType()==INTERFACE_DEF)) {
					typeDefinition(_t);
					_t = _retTree;
				}
				else {
					break _loop6;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void packageDefinition(AST _t) throws RecognitionException {
		
		MyCommonAST packageDefinition_AST_in = (MyCommonAST)_t;
		Object ignore;
		
		try {      // for error handling
			AST __t8 = _t;
			MyCommonAST tmp1_AST_in = (MyCommonAST)_t;
			match(_t,PACKAGE_DEF);
			_t = _t.getFirstChild();
			ignore=identifier(_t);
			_t = _retTree;
			_t = __t8;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void importDefinition(AST _t) throws RecognitionException {
		
		MyCommonAST importDefinition_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t10 = _t;
			MyCommonAST tmp2_AST_in = (MyCommonAST)_t;
			match(_t,IMPORT);
			_t = _t.getFirstChild();
			identifierStar(_t);
			_t = _retTree;
			_t = __t10;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void typeDefinition(AST _t) throws RecognitionException {
		
		MyCommonAST typeDefinition_AST_in = (MyCommonAST)_t;
		
		MyModifierSet mods;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CLASS_DEF:
			{
				AST __t12 = _t;
				MyCommonAST tmp3_AST_in = (MyCommonAST)_t;
				match(_t,CLASS_DEF);
				_t = _t.getFirstChild();
				mods=modifiers(_t);
				_t = _retTree;
				MyCommonAST tmp4_AST_in = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				extendsClause(_t);
				_t = _retTree;
				implementsClause(_t);
				_t = _retTree;
				objBlock(_t);
				_t = _retTree;
				_t = __t12;
				_t = _t.getNextSibling();
				
				ver.verifyType(mods, tmp4_AST_in);
				
				break;
			}
			case INTERFACE_DEF:
			{
				AST __t13 = _t;
				MyCommonAST tmp5_AST_in = (MyCommonAST)_t;
				match(_t,INTERFACE_DEF);
				_t = _t.getFirstChild();
				mods=modifiers(_t);
				_t = _retTree;
				MyCommonAST tmp6_AST_in = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				extendsClause(_t);
				_t = _retTree;
				interfaceBlock(_t);
				_t = _retTree;
				_t = __t13;
				_t = _t.getNextSibling();
				
				ver.verifyType(mods, tmp6_AST_in);
				
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final LineText  identifier(AST _t) throws RecognitionException {
		LineText r;
		
		MyCommonAST identifier_AST_in = (MyCommonAST)_t;
		MyCommonAST i = null;
		MyCommonAST b = null;
		
		r = null;
		LineText a;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IDENT:
			{
				i = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				
				r = new LineText(i.getLineNo(), i.getText());
				
				break;
			}
			case DOT:
			{
				AST __t74 = _t;
				MyCommonAST tmp7_AST_in = (MyCommonAST)_t;
				match(_t,DOT);
				_t = _t.getFirstChild();
				a=identifier(_t);
				_t = _retTree;
				b = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				_t = __t74;
				_t = _t.getNextSibling();
				
				r = new LineText(a);
				r.appendText("." + b.getText());
				
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void identifierStar(AST _t) throws RecognitionException {
		
		MyCommonAST identifierStar_AST_in = (MyCommonAST)_t;
		Object ignore;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IDENT:
			{
				MyCommonAST tmp8_AST_in = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				break;
			}
			case DOT:
			{
				AST __t76 = _t;
				MyCommonAST tmp9_AST_in = (MyCommonAST)_t;
				match(_t,DOT);
				_t = _t.getFirstChild();
				ignore=identifier(_t);
				_t = _retTree;
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case STAR:
				{
					MyCommonAST tmp10_AST_in = (MyCommonAST)_t;
					match(_t,STAR);
					_t = _t.getNextSibling();
					break;
				}
				case IDENT:
				{
					MyCommonAST tmp11_AST_in = (MyCommonAST)_t;
					match(_t,IDENT);
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t76;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final MyModifierSet  modifiers(AST _t) throws RecognitionException {
		MyModifierSet r;
		
		MyCommonAST modifiers_AST_in = (MyCommonAST)_t;
		MyCommonAST m = null;
		
		r = new MyModifierSet();
		
		
		try {      // for error handling
			AST __t21 = _t;
			MyCommonAST tmp12_AST_in = (MyCommonAST)_t;
			match(_t,MODIFIERS);
			_t = _t.getFirstChild();
			{
			_loop23:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					m = _t==ASTNULL ? null : (MyCommonAST)_t;
					modifier(_t);
					_t = _retTree;
					r.addModifier(m);
				}
				else {
					break _loop23;
				}
				
			} while (true);
			}
			_t = __t21;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void extendsClause(AST _t) throws RecognitionException {
		
		MyCommonAST extendsClause_AST_in = (MyCommonAST)_t;
		Object ignore;
		
		try {      // for error handling
			AST __t26 = _t;
			MyCommonAST tmp13_AST_in = (MyCommonAST)_t;
			match(_t,EXTENDS_CLAUSE);
			_t = _t.getFirstChild();
			{
			_loop28:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==IDENT||_t.getType()==DOT)) {
					ignore=identifier(_t);
					_t = _retTree;
				}
				else {
					break _loop28;
				}
				
			} while (true);
			}
			_t = __t26;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void implementsClause(AST _t) throws RecognitionException {
		
		MyCommonAST implementsClause_AST_in = (MyCommonAST)_t;
		Object ignore;
		
		try {      // for error handling
			AST __t30 = _t;
			MyCommonAST tmp14_AST_in = (MyCommonAST)_t;
			match(_t,IMPLEMENTS_CLAUSE);
			_t = _t.getFirstChild();
			{
			_loop32:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==IDENT||_t.getType()==DOT)) {
					ignore=identifier(_t);
					_t = _retTree;
				}
				else {
					break _loop32;
				}
				
			} while (true);
			}
			_t = __t30;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void objBlock(AST _t) throws RecognitionException {
		
		MyCommonAST objBlock_AST_in = (MyCommonAST)_t;
		
		MyVariable var;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			AST __t38 = _t;
			MyCommonAST tmp15_AST_in = (MyCommonAST)_t;
			match(_t,OBJBLOCK);
			_t = _t.getFirstChild();
			{
			_loop42:
			do {
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case CTOR_DEF:
				{
					ctorDef(_t);
					_t = _retTree;
					break;
				}
				case METHOD_DEF:
				{
					methodDef(_t);
					_t = _retTree;
					break;
				}
				case VARIABLE_DEF:
				{
					var=variableDef(_t);
					_t = _retTree;
					ver.verifyVariable(var, false);
					break;
				}
				case CLASS_DEF:
				case INTERFACE_DEF:
				{
					typeDefinition(_t);
					_t = _retTree;
					break;
				}
				case STATIC_INIT:
				{
					AST __t40 = _t;
					MyCommonAST tmp16_AST_in = (MyCommonAST)_t;
					match(_t,STATIC_INIT);
					_t = _t.getFirstChild();
					slist(_t);
					_t = _retTree;
					_t = __t40;
					_t = _t.getNextSibling();
					break;
				}
				case INSTANCE_INIT:
				{
					AST __t41 = _t;
					MyCommonAST tmp17_AST_in = (MyCommonAST)_t;
					match(_t,INSTANCE_INIT);
					_t = _t.getFirstChild();
					slist(_t);
					_t = _retTree;
					_t = __t41;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					break _loop42;
				}
				}
			} while (true);
			}
			_t = __t38;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void interfaceBlock(AST _t) throws RecognitionException {
		
		MyCommonAST interfaceBlock_AST_in = (MyCommonAST)_t;
		
		MyVariable var;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			AST __t34 = _t;
			MyCommonAST tmp18_AST_in = (MyCommonAST)_t;
			match(_t,OBJBLOCK);
			_t = _t.getFirstChild();
			{
			_loop36:
			do {
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case METHOD_DEF:
				{
					methodDecl(_t);
					_t = _retTree;
					break;
				}
				case VARIABLE_DEF:
				{
					var=variableDef(_t);
					_t = _retTree;
					ver.verifyVariable(var, true);
					break;
				}
				case CLASS_DEF:
				case INTERFACE_DEF:
				{
					typeDefinition(_t);
					_t = _retTree;
					break;
				}
				default:
				{
					break _loop36;
				}
				}
			} while (true);
			}
			_t = __t34;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void typeSpec(AST _t) throws RecognitionException {
		
		MyCommonAST typeSpec_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t15 = _t;
			MyCommonAST tmp19_AST_in = (MyCommonAST)_t;
			match(_t,TYPE);
			_t = _t.getFirstChild();
			typeSpecArray(_t);
			_t = _retTree;
			_t = __t15;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void typeSpecArray(AST _t) throws RecognitionException {
		
		MyCommonAST typeSpecArray_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ARRAY_DECLARATOR:
			{
				AST __t17 = _t;
				MyCommonAST tmp20_AST_in = (MyCommonAST)_t;
				match(_t,ARRAY_DECLARATOR);
				_t = _t.getFirstChild();
				typeSpecArray(_t);
				_t = _retTree;
				_t = __t17;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_void:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_short:
			case LITERAL_int:
			case LITERAL_float:
			case LITERAL_long:
			case LITERAL_double:
			case IDENT:
			case DOT:
			{
				type(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void type(AST _t) throws RecognitionException {
		
		MyCommonAST type_AST_in = (MyCommonAST)_t;
		Object ignore;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IDENT:
			case DOT:
			{
				ignore=identifier(_t);
				_t = _retTree;
				break;
			}
			case LITERAL_void:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_short:
			case LITERAL_int:
			case LITERAL_float:
			case LITERAL_long:
			case LITERAL_double:
			{
				builtInType(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void builtInType(AST _t) throws RecognitionException {
		
		MyCommonAST builtInType_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_void:
			{
				MyCommonAST tmp21_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_void);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_boolean:
			{
				MyCommonAST tmp22_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_boolean);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_byte:
			{
				MyCommonAST tmp23_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_byte);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_char:
			{
				MyCommonAST tmp24_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_char);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_short:
			{
				MyCommonAST tmp25_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_short);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_int:
			{
				MyCommonAST tmp26_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_float:
			{
				MyCommonAST tmp27_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_long:
			{
				MyCommonAST tmp28_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_long);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_double:
			{
				MyCommonAST tmp29_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_double);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void modifier(AST _t) throws RecognitionException {
		
		MyCommonAST modifier_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_private:
			{
				MyCommonAST tmp30_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_private);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_public:
			{
				MyCommonAST tmp31_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_public);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_protected:
			{
				MyCommonAST tmp32_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_protected);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_static:
			{
				MyCommonAST tmp33_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_static);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_transient:
			{
				MyCommonAST tmp34_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_transient);
				_t = _t.getNextSibling();
				break;
			}
			case FINAL:
			{
				MyCommonAST tmp35_AST_in = (MyCommonAST)_t;
				match(_t,FINAL);
				_t = _t.getNextSibling();
				break;
			}
			case ABSTRACT:
			{
				MyCommonAST tmp36_AST_in = (MyCommonAST)_t;
				match(_t,ABSTRACT);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_native:
			{
				MyCommonAST tmp37_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_native);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_threadsafe:
			{
				MyCommonAST tmp38_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_threadsafe);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_synchronized:
			{
				MyCommonAST tmp39_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_synchronized);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_const:
			{
				MyCommonAST tmp40_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_const);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_volatile:
			{
				MyCommonAST tmp41_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_volatile);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void methodDecl(AST _t) throws RecognitionException {
		
		MyCommonAST methodDecl_AST_in = (MyCommonAST)_t;
		MyCommonAST ts = null;
		
		MyModifierSet mods;
		MethodSignature ms;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			AST __t46 = _t;
			MyCommonAST tmp42_AST_in = (MyCommonAST)_t;
			match(_t,METHOD_DEF);
			_t = _t.getFirstChild();
			mods=modifiers(_t);
			_t = _retTree;
			ts = _t==ASTNULL ? null : (MyCommonAST)_t;
			typeSpec(_t);
			_t = _retTree;
			ms=methodHead(_t);
			_t = _retTree;
			_t = __t46;
			_t = _t.getNextSibling();
			
			ver.verifyMethodJavadoc(mods, ts, ms);
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final MyVariable  variableDef(AST _t) throws RecognitionException {
		MyVariable r;
		
		MyCommonAST variableDef_AST_in = (MyCommonAST)_t;
		
		MyModifierSet mods;
		LineText name;
		r = null;
		
		
		try {      // for error handling
			AST __t51 = _t;
			MyCommonAST tmp43_AST_in = (MyCommonAST)_t;
			match(_t,VARIABLE_DEF);
			_t = _t.getFirstChild();
			mods=modifiers(_t);
			_t = _retTree;
			typeSpec(_t);
			_t = _retTree;
			name=variableDeclarator(_t);
			_t = _retTree;
			varInitializer(_t);
			_t = _retTree;
			_t = __t51;
			_t = _t.getNextSibling();
			
			r = new MyVariable(name, mods);
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void ctorDef(AST _t) throws RecognitionException {
		
		MyCommonAST ctorDef_AST_in = (MyCommonAST)_t;
		
		MyModifierSet mods;
		MethodSignature ms;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			AST __t44 = _t;
			MyCommonAST tmp44_AST_in = (MyCommonAST)_t;
			match(_t,CTOR_DEF);
			_t = _t.getFirstChild();
			mods=modifiers(_t);
			_t = _retTree;
			ms=methodHead(_t);
			_t = _retTree;
			slist(_t);
			_t = _retTree;
			_t = __t44;
			_t = _t.getNextSibling();
			
			ver.verifyMethodJavadoc(mods, null, ms);
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void methodDef(AST _t) throws RecognitionException {
		
		MyCommonAST methodDef_AST_in = (MyCommonAST)_t;
		MyCommonAST ts = null;
		
		MyModifierSet mods;
		MethodSignature ms;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			AST __t48 = _t;
			MyCommonAST tmp45_AST_in = (MyCommonAST)_t;
			match(_t,METHOD_DEF);
			_t = _t.getFirstChild();
			mods=modifiers(_t);
			_t = _retTree;
			ts = _t==ASTNULL ? null : (MyCommonAST)_t;
			typeSpec(_t);
			_t = _retTree;
			ms=methodHead(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SLIST:
			{
				slist(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t48;
			_t = _t.getNextSibling();
			
			ver.verifyMethodJavadoc(mods, ts, ms);
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void slist(AST _t) throws RecognitionException {
		
		MyCommonAST slist_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t79 = _t;
			MyCommonAST tmp46_AST_in = (MyCommonAST)_t;
			match(_t,SLIST);
			_t = _t.getFirstChild();
			{
			_loop81:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_1.member(_t.getType()))) {
					stat(_t);
					_t = _retTree;
				}
				else {
					break _loop81;
				}
				
			} while (true);
			}
			_t = __t79;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final MethodSignature  methodHead(AST _t) throws RecognitionException {
		MethodSignature r;
		
		MyCommonAST methodHead_AST_in = (MyCommonAST)_t;
		MyCommonAST ii = null;
		
		r = new MethodSignature();
		java.util.List throwsList = new java.util.ArrayList(); // emtpy list
		LineText p = null;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			ii = (MyCommonAST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			AST __t65 = _t;
			MyCommonAST tmp47_AST_in = (MyCommonAST)_t;
			match(_t,PARAMETERS);
			_t = _t.getFirstChild();
			{
			_loop67:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==PARAMETER_DEF)) {
					p=parameterDef(_t);
					_t = _retTree;
					ver.verifyParameter(p); r.addParam(p);
				}
				else {
					break _loop67;
				}
				
			} while (true);
			}
			_t = __t65;
			_t = _t.getNextSibling();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_throws:
			{
				throwsList=throwsClause(_t);
				_t = _retTree;
				break;
			}
			case 3:
			case SLIST:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			
			r.setLineNo(ii.getLineNo());
			r.setThrows(throwsList);
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final LineText  variableDeclarator(AST _t) throws RecognitionException {
		LineText r;
		
		MyCommonAST variableDeclarator_AST_in = (MyCommonAST)_t;
		MyCommonAST ii = null;
		
		Object ignore;
		r = null;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IDENT:
			{
				ii = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				
				r = new LineText(ii.getLineNo(), ii.getText());
				
				break;
			}
			case LBRACK:
			{
				MyCommonAST tmp48_AST_in = (MyCommonAST)_t;
				match(_t,LBRACK);
				_t = _t.getNextSibling();
				ignore=variableDeclarator(_t);
				_t = _retTree;
				
				// Not sure how to handle this?
				System.out.println("Report this breakage to Oliver. " +
				"Remember the input file!");
				System.exit(1);
				
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void varInitializer(AST _t) throws RecognitionException {
		
		MyCommonAST varInitializer_AST_in = (MyCommonAST)_t;
		
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ASSIGN:
			{
				AST __t58 = _t;
				MyCommonAST tmp49_AST_in = (MyCommonAST)_t;
				match(_t,ASSIGN);
				_t = _t.getFirstChild();
				initializer(_t);
				_t = _retTree;
				_t = __t58;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp49_AST_in);
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final LineText  parameterDef(AST _t) throws RecognitionException {
		LineText r;
		
		MyCommonAST parameterDef_AST_in = (MyCommonAST)_t;
		MyCommonAST ii = null;
		
		r = null;
		Object ignore;
		
		
		try {      // for error handling
			AST __t53 = _t;
			MyCommonAST tmp50_AST_in = (MyCommonAST)_t;
			match(_t,PARAMETER_DEF);
			_t = _t.getFirstChild();
			ignore=modifiers(_t);
			_t = _retTree;
			typeSpec(_t);
			_t = _retTree;
			ii = (MyCommonAST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			_t = __t53;
			_t = _t.getNextSibling();
			
			r = new LineText(ii.getLineNo(), ii.getText());
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void objectinitializer(AST _t) throws RecognitionException {
		
		MyCommonAST objectinitializer_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t55 = _t;
			MyCommonAST tmp51_AST_in = (MyCommonAST)_t;
			match(_t,INSTANCE_INIT);
			_t = _t.getFirstChild();
			slist(_t);
			_t = _retTree;
			_t = __t55;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void initializer(AST _t) throws RecognitionException {
		
		MyCommonAST initializer_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case EXPR:
			{
				expression(_t);
				_t = _retTree;
				break;
			}
			case ARRAY_INIT:
			{
				arrayInitializer(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void expression(AST _t) throws RecognitionException {
		
		MyCommonAST expression_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t124 = _t;
			MyCommonAST tmp52_AST_in = (MyCommonAST)_t;
			match(_t,EXPR);
			_t = _t.getFirstChild();
			expr(_t);
			_t = _retTree;
			_t = __t124;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void arrayInitializer(AST _t) throws RecognitionException {
		
		MyCommonAST arrayInitializer_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t61 = _t;
			MyCommonAST tmp53_AST_in = (MyCommonAST)_t;
			match(_t,ARRAY_INIT);
			_t = _t.getFirstChild();
			{
			_loop63:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==EXPR||_t.getType()==ARRAY_INIT)) {
					initializer(_t);
					_t = _retTree;
				}
				else {
					break _loop63;
				}
				
			} while (true);
			}
			_t = __t61;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final java.util.List  throwsClause(AST _t) throws RecognitionException {
		java.util.List r;
		
		MyCommonAST throwsClause_AST_in = (MyCommonAST)_t;
		
		LineText name;
		r = new java.util.ArrayList();
		
		
		try {      // for error handling
			AST __t70 = _t;
			MyCommonAST tmp54_AST_in = (MyCommonAST)_t;
			match(_t,LITERAL_throws);
			_t = _t.getFirstChild();
			{
			_loop72:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==IDENT||_t.getType()==DOT)) {
					name=identifier(_t);
					_t = _retTree;
					r.add(name);
				}
				else {
					break _loop72;
				}
				
			} while (true);
			}
			_t = __t70;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void stat(AST _t) throws RecognitionException {
		
		MyCommonAST stat_AST_in = (MyCommonAST)_t;
		MyCommonAST ii = null;
		MyCommonAST is1 = null;
		MyCommonAST is2 = null;
		MyCommonAST ff = null;
		MyCommonAST fs = null;
		MyCommonAST ww = null;
		MyCommonAST ws = null;
		MyCommonAST dd = null;
		MyCommonAST ds = null;
		
		Object ignore;
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case CLASS_DEF:
			case INTERFACE_DEF:
			{
				typeDefinition(_t);
				_t = _retTree;
				break;
			}
			case VARIABLE_DEF:
			{
				ignore=variableDef(_t);
				_t = _retTree;
				break;
			}
			case EXPR:
			{
				expression(_t);
				_t = _retTree;
				break;
			}
			case LABELED_STAT:
			{
				AST __t83 = _t;
				MyCommonAST tmp55_AST_in = (MyCommonAST)_t;
				match(_t,LABELED_STAT);
				_t = _t.getFirstChild();
				MyCommonAST tmp56_AST_in = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				stat(_t);
				_t = _retTree;
				_t = __t83;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_if:
			{
				AST __t84 = _t;
				ii = _t==ASTNULL ? null :(MyCommonAST)_t;
				match(_t,LITERAL_if);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				is1 = _t==ASTNULL ? null : (MyCommonAST)_t;
				stat(_t);
				_t = _retTree;
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case SLIST:
				case VARIABLE_DEF:
				case CLASS_DEF:
				case INTERFACE_DEF:
				case LABELED_STAT:
				case EXPR:
				case EMPTY_STAT:
				case LITERAL_synchronized:
				case LITERAL_if:
				case LITERAL_for:
				case LITERAL_while:
				case LITERAL_do:
				case LITERAL_break:
				case LITERAL_continue:
				case LITERAL_return:
				case LITERAL_switch:
				case LITERAL_throw:
				case LITERAL_try:
				{
					is2 = _t==ASTNULL ? null : (MyCommonAST)_t;
					stat(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t84;
				_t = _t.getNextSibling();
				
				ver.verifyLeftCurly(is1.getText(), false, "if", ii.getLineNo());
				ver.verifySurroundingWS(ii);
				ver.verifySurroundingWS(is1);
				if (is2 != null) {
				ver.verifyLeftCurly(is2.getText(), true, "else", ii.getLineNo());
				ver.verifySurroundingWS(is2);
				}
				
				break;
			}
			case LITERAL_for:
			{
				AST __t86 = _t;
				ff = _t==ASTNULL ? null :(MyCommonAST)_t;
				match(_t,LITERAL_for);
				_t = _t.getFirstChild();
				AST __t87 = _t;
				MyCommonAST tmp57_AST_in = (MyCommonAST)_t;
				match(_t,FOR_INIT);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case VARIABLE_DEF:
				{
					ignore=variableDef(_t);
					_t = _retTree;
					break;
				}
				case ELIST:
				{
					elist(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t87;
				_t = _t.getNextSibling();
				AST __t89 = _t;
				MyCommonAST tmp58_AST_in = (MyCommonAST)_t;
				match(_t,FOR_CONDITION);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case EXPR:
				{
					expression(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t89;
				_t = _t.getNextSibling();
				AST __t91 = _t;
				MyCommonAST tmp59_AST_in = (MyCommonAST)_t;
				match(_t,FOR_ITERATOR);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case ELIST:
				{
					elist(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t91;
				_t = _t.getNextSibling();
				fs = _t==ASTNULL ? null : (MyCommonAST)_t;
				stat(_t);
				_t = _retTree;
				
				ver.verifyLeftCurly(fs.getText(), false, "for", ff.getLineNo());
				ver.verifySurroundingWS(ff);
				ver.verifySurroundingWS(fs);
				
				_t = __t86;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_while:
			{
				AST __t93 = _t;
				ww = _t==ASTNULL ? null :(MyCommonAST)_t;
				match(_t,LITERAL_while);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				ws = _t==ASTNULL ? null : (MyCommonAST)_t;
				stat(_t);
				_t = _retTree;
				_t = __t93;
				_t = _t.getNextSibling();
				
				ver.verifyLeftCurly(ws.getText(), false, "while", ww.getLineNo());
				ver.verifySurroundingWS(ww);
				ver.verifySurroundingWS(ws);
				
				break;
			}
			case LITERAL_do:
			{
				AST __t94 = _t;
				dd = _t==ASTNULL ? null :(MyCommonAST)_t;
				match(_t,LITERAL_do);
				_t = _t.getFirstChild();
				ds = _t==ASTNULL ? null : (MyCommonAST)_t;
				stat(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t94;
				_t = _t.getNextSibling();
				
				ver.verifyLeftCurly(ds.getText(), false, "do", dd.getLineNo());
				ver.verifySurroundingWS(dd);
				ver.verifySurroundingWS(ds);
				
				break;
			}
			case LITERAL_break:
			{
				AST __t95 = _t;
				MyCommonAST tmp60_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_break);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENT:
				{
					MyCommonAST tmp61_AST_in = (MyCommonAST)_t;
					match(_t,IDENT);
					_t = _t.getNextSibling();
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t95;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_continue:
			{
				AST __t97 = _t;
				MyCommonAST tmp62_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_continue);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENT:
				{
					MyCommonAST tmp63_AST_in = (MyCommonAST)_t;
					match(_t,IDENT);
					_t = _t.getNextSibling();
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t97;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_return:
			{
				AST __t99 = _t;
				MyCommonAST tmp64_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_return);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case EXPR:
				{
					expression(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t99;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_switch:
			{
				AST __t101 = _t;
				MyCommonAST tmp65_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_switch);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				{
				_loop103:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==CASE_GROUP)) {
						caseGroup(_t);
						_t = _retTree;
					}
					else {
						break _loop103;
					}
					
				} while (true);
				}
				_t = __t101;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_throw:
			{
				AST __t104 = _t;
				MyCommonAST tmp66_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_throw);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				_t = __t104;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_synchronized:
			{
				AST __t105 = _t;
				MyCommonAST tmp67_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_synchronized);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				stat(_t);
				_t = _retTree;
				_t = __t105;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_try:
			{
				tryBlock(_t);
				_t = _retTree;
				break;
			}
			case SLIST:
			{
				slist(_t);
				_t = _retTree;
				break;
			}
			case EMPTY_STAT:
			{
				MyCommonAST tmp68_AST_in = (MyCommonAST)_t;
				match(_t,EMPTY_STAT);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void elist(AST _t) throws RecognitionException {
		
		MyCommonAST elist_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t120 = _t;
			MyCommonAST tmp69_AST_in = (MyCommonAST)_t;
			match(_t,ELIST);
			_t = _t.getFirstChild();
			{
			_loop122:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==EXPR)) {
					expression(_t);
					_t = _retTree;
				}
				else {
					break _loop122;
				}
				
			} while (true);
			}
			_t = __t120;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void caseGroup(AST _t) throws RecognitionException {
		
		MyCommonAST caseGroup_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t107 = _t;
			MyCommonAST tmp70_AST_in = (MyCommonAST)_t;
			match(_t,CASE_GROUP);
			_t = _t.getFirstChild();
			{
			int _cnt110=0;
			_loop110:
			do {
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LITERAL_case:
				{
					AST __t109 = _t;
					MyCommonAST tmp71_AST_in = (MyCommonAST)_t;
					match(_t,LITERAL_case);
					_t = _t.getFirstChild();
					expression(_t);
					_t = _retTree;
					_t = __t109;
					_t = _t.getNextSibling();
					break;
				}
				case LITERAL_default:
				{
					MyCommonAST tmp72_AST_in = (MyCommonAST)_t;
					match(_t,LITERAL_default);
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					if ( _cnt110>=1 ) { break _loop110; } else {throw new NoViableAltException(_t);}
				}
				}
				_cnt110++;
			} while (true);
			}
			slist(_t);
			_t = _retTree;
			_t = __t107;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void tryBlock(AST _t) throws RecognitionException {
		
		MyCommonAST tryBlock_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t112 = _t;
			MyCommonAST tmp73_AST_in = (MyCommonAST)_t;
			match(_t,LITERAL_try);
			_t = _t.getFirstChild();
			slist(_t);
			_t = _retTree;
			{
			_loop114:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==LITERAL_catch)) {
					handler(_t);
					_t = _retTree;
				}
				else {
					break _loop114;
				}
				
			} while (true);
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_finally:
			{
				AST __t116 = _t;
				MyCommonAST tmp74_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_finally);
				_t = _t.getFirstChild();
				slist(_t);
				_t = _retTree;
				_t = __t116;
				_t = _t.getNextSibling();
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t112;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void handler(AST _t) throws RecognitionException {
		
		MyCommonAST handler_AST_in = (MyCommonAST)_t;
		Object ignore;
		
		try {      // for error handling
			AST __t118 = _t;
			MyCommonAST tmp75_AST_in = (MyCommonAST)_t;
			match(_t,LITERAL_catch);
			_t = _t.getFirstChild();
			ignore=parameterDef(_t);
			_t = _retTree;
			slist(_t);
			_t = _retTree;
			_t = __t118;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void expr(AST _t) throws RecognitionException {
		
		MyCommonAST expr_AST_in = (MyCommonAST)_t;
		
		Verifier ver = VerifierSingleton.getInstance();
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case QUESTION:
			{
				AST __t126 = _t;
				MyCommonAST tmp76_AST_in = (MyCommonAST)_t;
				match(_t,QUESTION);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				MyCommonAST tmp77_AST_in = (MyCommonAST)_t;
				match(_t,COLON);
				_t = _t.getNextSibling();
				expr(_t);
				_t = _retTree;
				_t = __t126;
				_t = _t.getNextSibling();
				
				ver.verifySurroundingWS(tmp76_AST_in);
				ver.verifySurroundingWS(tmp77_AST_in);
				
				break;
			}
			case ASSIGN:
			{
				AST __t127 = _t;
				MyCommonAST tmp78_AST_in = (MyCommonAST)_t;
				match(_t,ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t127;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp78_AST_in);
				break;
			}
			case PLUS_ASSIGN:
			{
				AST __t128 = _t;
				MyCommonAST tmp79_AST_in = (MyCommonAST)_t;
				match(_t,PLUS_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t128;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp79_AST_in);
				break;
			}
			case MINUS_ASSIGN:
			{
				AST __t129 = _t;
				MyCommonAST tmp80_AST_in = (MyCommonAST)_t;
				match(_t,MINUS_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t129;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp80_AST_in);
				break;
			}
			case STAR_ASSIGN:
			{
				AST __t130 = _t;
				MyCommonAST tmp81_AST_in = (MyCommonAST)_t;
				match(_t,STAR_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t130;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp81_AST_in);
				break;
			}
			case DIV_ASSIGN:
			{
				AST __t131 = _t;
				MyCommonAST tmp82_AST_in = (MyCommonAST)_t;
				match(_t,DIV_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t131;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp82_AST_in);
				break;
			}
			case MOD_ASSIGN:
			{
				AST __t132 = _t;
				MyCommonAST tmp83_AST_in = (MyCommonAST)_t;
				match(_t,MOD_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t132;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp83_AST_in);
				break;
			}
			case SR_ASSIGN:
			{
				AST __t133 = _t;
				MyCommonAST tmp84_AST_in = (MyCommonAST)_t;
				match(_t,SR_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t133;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp84_AST_in);
				break;
			}
			case BSR_ASSIGN:
			{
				AST __t134 = _t;
				MyCommonAST tmp85_AST_in = (MyCommonAST)_t;
				match(_t,BSR_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t134;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp85_AST_in);
				break;
			}
			case SL_ASSIGN:
			{
				AST __t135 = _t;
				MyCommonAST tmp86_AST_in = (MyCommonAST)_t;
				match(_t,SL_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t135;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp86_AST_in);
				break;
			}
			case BAND_ASSIGN:
			{
				AST __t136 = _t;
				MyCommonAST tmp87_AST_in = (MyCommonAST)_t;
				match(_t,BAND_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t136;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp87_AST_in);
				break;
			}
			case BXOR_ASSIGN:
			{
				AST __t137 = _t;
				MyCommonAST tmp88_AST_in = (MyCommonAST)_t;
				match(_t,BXOR_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t137;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp88_AST_in);
				break;
			}
			case BOR_ASSIGN:
			{
				AST __t138 = _t;
				MyCommonAST tmp89_AST_in = (MyCommonAST)_t;
				match(_t,BOR_ASSIGN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t138;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp89_AST_in);
				break;
			}
			case LOR:
			{
				AST __t139 = _t;
				MyCommonAST tmp90_AST_in = (MyCommonAST)_t;
				match(_t,LOR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t139;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp90_AST_in);
				break;
			}
			case LAND:
			{
				AST __t140 = _t;
				MyCommonAST tmp91_AST_in = (MyCommonAST)_t;
				match(_t,LAND);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t140;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp91_AST_in);
				break;
			}
			case BOR:
			{
				AST __t141 = _t;
				MyCommonAST tmp92_AST_in = (MyCommonAST)_t;
				match(_t,BOR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t141;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp92_AST_in);
				break;
			}
			case BXOR:
			{
				AST __t142 = _t;
				MyCommonAST tmp93_AST_in = (MyCommonAST)_t;
				match(_t,BXOR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t142;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp93_AST_in);
				break;
			}
			case BAND:
			{
				AST __t143 = _t;
				MyCommonAST tmp94_AST_in = (MyCommonAST)_t;
				match(_t,BAND);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t143;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp94_AST_in);
				break;
			}
			case NOT_EQUAL:
			{
				AST __t144 = _t;
				MyCommonAST tmp95_AST_in = (MyCommonAST)_t;
				match(_t,NOT_EQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t144;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp95_AST_in);
				break;
			}
			case EQUAL:
			{
				AST __t145 = _t;
				MyCommonAST tmp96_AST_in = (MyCommonAST)_t;
				match(_t,EQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t145;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp96_AST_in);
				break;
			}
			case LT:
			{
				AST __t146 = _t;
				MyCommonAST tmp97_AST_in = (MyCommonAST)_t;
				match(_t,LT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t146;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp97_AST_in);
				break;
			}
			case GT:
			{
				AST __t147 = _t;
				MyCommonAST tmp98_AST_in = (MyCommonAST)_t;
				match(_t,GT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t147;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp98_AST_in);
				break;
			}
			case LE:
			{
				AST __t148 = _t;
				MyCommonAST tmp99_AST_in = (MyCommonAST)_t;
				match(_t,LE);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t148;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp99_AST_in);
				break;
			}
			case GE:
			{
				AST __t149 = _t;
				MyCommonAST tmp100_AST_in = (MyCommonAST)_t;
				match(_t,GE);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t149;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp100_AST_in);
				break;
			}
			case SL:
			{
				AST __t150 = _t;
				MyCommonAST tmp101_AST_in = (MyCommonAST)_t;
				match(_t,SL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t150;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp101_AST_in);
				break;
			}
			case SR:
			{
				AST __t151 = _t;
				MyCommonAST tmp102_AST_in = (MyCommonAST)_t;
				match(_t,SR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t151;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp102_AST_in);
				break;
			}
			case BSR:
			{
				AST __t152 = _t;
				MyCommonAST tmp103_AST_in = (MyCommonAST)_t;
				match(_t,BSR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t152;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp103_AST_in);
				break;
			}
			case PLUS:
			{
				AST __t153 = _t;
				MyCommonAST tmp104_AST_in = (MyCommonAST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t153;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp104_AST_in);
				break;
			}
			case MINUS:
			{
				AST __t154 = _t;
				MyCommonAST tmp105_AST_in = (MyCommonAST)_t;
				match(_t,MINUS);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t154;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp105_AST_in);
				break;
			}
			case DIV:
			{
				AST __t155 = _t;
				MyCommonAST tmp106_AST_in = (MyCommonAST)_t;
				match(_t,DIV);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t155;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp106_AST_in);
				break;
			}
			case MOD:
			{
				AST __t156 = _t;
				MyCommonAST tmp107_AST_in = (MyCommonAST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t156;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp107_AST_in);
				break;
			}
			case STAR:
			{
				AST __t157 = _t;
				MyCommonAST tmp108_AST_in = (MyCommonAST)_t;
				match(_t,STAR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t157;
				_t = _t.getNextSibling();
				ver.verifySurroundingWS(tmp108_AST_in);
				break;
			}
			case INC:
			{
				AST __t158 = _t;
				MyCommonAST tmp109_AST_in = (MyCommonAST)_t;
				match(_t,INC);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t158;
				_t = _t.getNextSibling();
				ver.verifyNoWSAfter(tmp109_AST_in);
				break;
			}
			case DEC:
			{
				AST __t159 = _t;
				MyCommonAST tmp110_AST_in = (MyCommonAST)_t;
				match(_t,DEC);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t159;
				_t = _t.getNextSibling();
				ver.verifyNoWSAfter(tmp110_AST_in);
				break;
			}
			case POST_INC:
			{
				AST __t160 = _t;
				MyCommonAST tmp111_AST_in = (MyCommonAST)_t;
				match(_t,POST_INC);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t160;
				_t = _t.getNextSibling();
				ver.verifyNoWSBefore(tmp111_AST_in);
				break;
			}
			case POST_DEC:
			{
				AST __t161 = _t;
				MyCommonAST tmp112_AST_in = (MyCommonAST)_t;
				match(_t,POST_DEC);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t161;
				_t = _t.getNextSibling();
				ver.verifyNoWSBefore(tmp112_AST_in);
				break;
			}
			case BNOT:
			{
				AST __t162 = _t;
				MyCommonAST tmp113_AST_in = (MyCommonAST)_t;
				match(_t,BNOT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t162;
				_t = _t.getNextSibling();
				ver.verifyNoWSAfter(tmp113_AST_in);
				break;
			}
			case LNOT:
			{
				AST __t163 = _t;
				MyCommonAST tmp114_AST_in = (MyCommonAST)_t;
				match(_t,LNOT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t163;
				_t = _t.getNextSibling();
				ver.verifyNoWSAfter(tmp114_AST_in);
				break;
			}
			case LITERAL_instanceof:
			{
				AST __t164 = _t;
				MyCommonAST tmp115_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_instanceof);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t164;
				_t = _t.getNextSibling();
				break;
			}
			case UNARY_MINUS:
			{
				AST __t165 = _t;
				MyCommonAST tmp116_AST_in = (MyCommonAST)_t;
				match(_t,UNARY_MINUS);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t165;
				_t = _t.getNextSibling();
				ver.verifyNoWSAfter(tmp116_AST_in);
				break;
			}
			case UNARY_PLUS:
			{
				AST __t166 = _t;
				MyCommonAST tmp117_AST_in = (MyCommonAST)_t;
				match(_t,UNARY_PLUS);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				_t = __t166;
				_t = _t.getNextSibling();
				ver.verifyNoWSAfter(tmp117_AST_in);
				break;
			}
			case TYPE:
			case TYPECAST:
			case INDEX_OP:
			case METHOD_CALL:
			case IDENT:
			case DOT:
			case LITERAL_this:
			case LITERAL_super:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_null:
			case LITERAL_new:
			case NUM_INT:
			case CHAR_LITERAL:
			case STRING_LITERAL:
			case NUM_FLOAT:
			{
				primaryExpression(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void primaryExpression(AST _t) throws RecognitionException {
		
		MyCommonAST primaryExpression_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case IDENT:
			{
				MyCommonAST tmp118_AST_in = (MyCommonAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				break;
			}
			case DOT:
			{
				AST __t168 = _t;
				MyCommonAST tmp119_AST_in = (MyCommonAST)_t;
				match(_t,DOT);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case TYPE:
				case TYPECAST:
				case INDEX_OP:
				case POST_INC:
				case POST_DEC:
				case METHOD_CALL:
				case UNARY_MINUS:
				case UNARY_PLUS:
				case IDENT:
				case DOT:
				case STAR:
				case ASSIGN:
				case PLUS_ASSIGN:
				case MINUS_ASSIGN:
				case STAR_ASSIGN:
				case DIV_ASSIGN:
				case MOD_ASSIGN:
				case SR_ASSIGN:
				case BSR_ASSIGN:
				case SL_ASSIGN:
				case BAND_ASSIGN:
				case BXOR_ASSIGN:
				case BOR_ASSIGN:
				case QUESTION:
				case LOR:
				case LAND:
				case BOR:
				case BXOR:
				case BAND:
				case NOT_EQUAL:
				case EQUAL:
				case LT:
				case GT:
				case LE:
				case GE:
				case LITERAL_instanceof:
				case SL:
				case SR:
				case BSR:
				case PLUS:
				case MINUS:
				case DIV:
				case MOD:
				case INC:
				case DEC:
				case BNOT:
				case LNOT:
				case LITERAL_this:
				case LITERAL_super:
				case LITERAL_true:
				case LITERAL_false:
				case LITERAL_null:
				case LITERAL_new:
				case NUM_INT:
				case CHAR_LITERAL:
				case STRING_LITERAL:
				case NUM_FLOAT:
				{
					expr(_t);
					_t = _retTree;
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case IDENT:
					{
						MyCommonAST tmp120_AST_in = (MyCommonAST)_t;
						match(_t,IDENT);
						_t = _t.getNextSibling();
						break;
					}
					case INDEX_OP:
					{
						arrayIndex(_t);
						_t = _retTree;
						break;
					}
					case LITERAL_this:
					{
						MyCommonAST tmp121_AST_in = (MyCommonAST)_t;
						match(_t,LITERAL_this);
						_t = _t.getNextSibling();
						break;
					}
					case LITERAL_class:
					{
						MyCommonAST tmp122_AST_in = (MyCommonAST)_t;
						match(_t,LITERAL_class);
						_t = _t.getNextSibling();
						break;
					}
					case LITERAL_new:
					{
						AST __t171 = _t;
						MyCommonAST tmp123_AST_in = (MyCommonAST)_t;
						match(_t,LITERAL_new);
						_t = _t.getFirstChild();
						MyCommonAST tmp124_AST_in = (MyCommonAST)_t;
						match(_t,IDENT);
						_t = _t.getNextSibling();
						elist(_t);
						_t = _retTree;
						_t = __t171;
						_t = _t.getNextSibling();
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					break;
				}
				case ARRAY_DECLARATOR:
				{
					AST __t172 = _t;
					MyCommonAST tmp125_AST_in = (MyCommonAST)_t;
					match(_t,ARRAY_DECLARATOR);
					_t = _t.getFirstChild();
					type(_t);
					_t = _retTree;
					_t = __t172;
					_t = _t.getNextSibling();
					break;
				}
				case LITERAL_void:
				case LITERAL_boolean:
				case LITERAL_byte:
				case LITERAL_char:
				case LITERAL_short:
				case LITERAL_int:
				case LITERAL_float:
				case LITERAL_long:
				case LITERAL_double:
				{
					builtInType(_t);
					_t = _retTree;
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case LITERAL_class:
					{
						MyCommonAST tmp126_AST_in = (MyCommonAST)_t;
						match(_t,LITERAL_class);
						_t = _t.getNextSibling();
						break;
					}
					case 3:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t168;
				_t = _t.getNextSibling();
				break;
			}
			case INDEX_OP:
			{
				arrayIndex(_t);
				_t = _retTree;
				break;
			}
			case METHOD_CALL:
			{
				AST __t174 = _t;
				MyCommonAST tmp127_AST_in = (MyCommonAST)_t;
				match(_t,METHOD_CALL);
				_t = _t.getFirstChild();
				primaryExpression(_t);
				_t = _retTree;
				elist(_t);
				_t = _retTree;
				_t = __t174;
				_t = _t.getNextSibling();
				break;
			}
			case TYPECAST:
			{
				AST __t175 = _t;
				MyCommonAST tmp128_AST_in = (MyCommonAST)_t;
				match(_t,TYPECAST);
				_t = _t.getFirstChild();
				typeSpec(_t);
				_t = _retTree;
				expr(_t);
				_t = _retTree;
				_t = __t175;
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_new:
			{
				newExpression(_t);
				_t = _retTree;
				break;
			}
			case NUM_INT:
			case CHAR_LITERAL:
			case STRING_LITERAL:
			case NUM_FLOAT:
			{
				constant(_t);
				_t = _retTree;
				break;
			}
			case LITERAL_super:
			{
				MyCommonAST tmp129_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_super);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_true:
			{
				MyCommonAST tmp130_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_true);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_false:
			{
				MyCommonAST tmp131_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_false);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_this:
			{
				MyCommonAST tmp132_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_this);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_null:
			{
				MyCommonAST tmp133_AST_in = (MyCommonAST)_t;
				match(_t,LITERAL_null);
				_t = _t.getNextSibling();
				break;
			}
			case TYPE:
			{
				typeSpec(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void arrayIndex(AST _t) throws RecognitionException {
		
		MyCommonAST arrayIndex_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t177 = _t;
			MyCommonAST tmp134_AST_in = (MyCommonAST)_t;
			match(_t,INDEX_OP);
			_t = _t.getFirstChild();
			primaryExpression(_t);
			_t = _retTree;
			expression(_t);
			_t = _retTree;
			_t = __t177;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void newExpression(AST _t) throws RecognitionException {
		
		MyCommonAST newExpression_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t180 = _t;
			MyCommonAST tmp135_AST_in = (MyCommonAST)_t;
			match(_t,LITERAL_new);
			_t = _t.getFirstChild();
			type(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ARRAY_DECLARATOR:
			{
				newArrayDeclarator(_t);
				_t = _retTree;
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case ARRAY_INIT:
				{
					arrayInitializer(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				break;
			}
			case ELIST:
			{
				elist(_t);
				_t = _retTree;
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case OBJBLOCK:
				{
					objBlock(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t180;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void constant(AST _t) throws RecognitionException {
		
		MyCommonAST constant_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case NUM_INT:
			{
				MyCommonAST tmp136_AST_in = (MyCommonAST)_t;
				match(_t,NUM_INT);
				_t = _t.getNextSibling();
				break;
			}
			case CHAR_LITERAL:
			{
				MyCommonAST tmp137_AST_in = (MyCommonAST)_t;
				match(_t,CHAR_LITERAL);
				_t = _t.getNextSibling();
				break;
			}
			case STRING_LITERAL:
			{
				MyCommonAST tmp138_AST_in = (MyCommonAST)_t;
				match(_t,STRING_LITERAL);
				_t = _t.getNextSibling();
				break;
			}
			case NUM_FLOAT:
			{
				MyCommonAST tmp139_AST_in = (MyCommonAST)_t;
				match(_t,NUM_FLOAT);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void newArrayDeclarator(AST _t) throws RecognitionException {
		
		MyCommonAST newArrayDeclarator_AST_in = (MyCommonAST)_t;
		
		try {      // for error handling
			AST __t185 = _t;
			MyCommonAST tmp140_AST_in = (MyCommonAST)_t;
			match(_t,ARRAY_DECLARATOR);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ARRAY_DECLARATOR:
			{
				newArrayDeclarator(_t);
				_t = _retTree;
				break;
			}
			case 3:
			case EXPR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case EXPR:
			{
				expression(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t185;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"BLOCK",
		"MODIFIERS",
		"OBJBLOCK",
		"SLIST",
		"CTOR_DEF",
		"METHOD_DEF",
		"VARIABLE_DEF",
		"INSTANCE_INIT",
		"STATIC_INIT",
		"TYPE",
		"CLASS_DEF",
		"INTERFACE_DEF",
		"PACKAGE_DEF",
		"ARRAY_DECLARATOR",
		"EXTENDS_CLAUSE",
		"IMPLEMENTS_CLAUSE",
		"PARAMETERS",
		"PARAMETER_DEF",
		"LABELED_STAT",
		"TYPECAST",
		"INDEX_OP",
		"POST_INC",
		"POST_DEC",
		"METHOD_CALL",
		"EXPR",
		"ARRAY_INIT",
		"IMPORT",
		"UNARY_MINUS",
		"UNARY_PLUS",
		"CASE_GROUP",
		"ELIST",
		"FOR_INIT",
		"FOR_CONDITION",
		"FOR_ITERATOR",
		"EMPTY_STAT",
		"\"final\"",
		"\"abstract\"",
		"\"package\"",
		"SEMI",
		"\"import\"",
		"LBRACK",
		"RBRACK",
		"\"void\"",
		"\"boolean\"",
		"\"byte\"",
		"\"char\"",
		"\"short\"",
		"\"int\"",
		"\"float\"",
		"\"long\"",
		"\"double\"",
		"IDENT",
		"DOT",
		"STAR",
		"\"private\"",
		"\"public\"",
		"\"protected\"",
		"\"static\"",
		"\"transient\"",
		"\"native\"",
		"\"threadsafe\"",
		"\"synchronized\"",
		"\"volatile\"",
		"\"class\"",
		"\"extends\"",
		"\"interface\"",
		"LCURLY",
		"RCURLY",
		"COMMA",
		"\"implements\"",
		"LPAREN",
		"RPAREN",
		"ASSIGN",
		"\"throws\"",
		"COLON",
		"\"if\"",
		"\"else\"",
		"\"for\"",
		"\"while\"",
		"\"do\"",
		"\"break\"",
		"\"continue\"",
		"\"return\"",
		"\"switch\"",
		"\"throw\"",
		"\"case\"",
		"\"default\"",
		"\"try\"",
		"\"finally\"",
		"\"catch\"",
		"PLUS_ASSIGN",
		"MINUS_ASSIGN",
		"STAR_ASSIGN",
		"DIV_ASSIGN",
		"MOD_ASSIGN",
		"SR_ASSIGN",
		"BSR_ASSIGN",
		"SL_ASSIGN",
		"BAND_ASSIGN",
		"BXOR_ASSIGN",
		"BOR_ASSIGN",
		"QUESTION",
		"LOR",
		"LAND",
		"BOR",
		"BXOR",
		"BAND",
		"NOT_EQUAL",
		"EQUAL",
		"LT",
		"GT",
		"LE",
		"GE",
		"\"instanceof\"",
		"SL",
		"SR",
		"BSR",
		"PLUS",
		"MINUS",
		"DIV",
		"MOD",
		"INC",
		"DEC",
		"BNOT",
		"LNOT",
		"\"this\"",
		"\"super\"",
		"\"true\"",
		"\"false\"",
		"\"null\"",
		"\"new\"",
		"NUM_INT",
		"CHAR_LITERAL",
		"STRING_LITERAL",
		"NUM_FLOAT",
		"WS",
		"SL_COMMENT",
		"ML_COMMENT",
		"ESC",
		"HEX_DIGIT",
		"VOCAB",
		"EXPONENT",
		"FLOAT_SUFFIX",
		"\"const\""
	};
	
	private static final long _tokenSet_0_data_[] = { -288228726884270080L, 7L, 524288L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 275150587008L, 167673858L, 0L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	}
	
